﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ControlVolume.Views
{
    public partial class Method2 : Form
    {
        [DllImport("Winmm.dll")]
        private static extern int waveOutSetVolume(int hwo, System.UInt32 pdwVolume); //设置音量
    
        [DllImport("Winmm.dll")]
        private static extern uint waveOutGetVolume(int hwo, out System.UInt32 pdwVolume); //获取音量


        int volume;//音量


        public Method2()
        {
            InitializeComponent();
        }


        public void getVolume()
        {
            uint v;
            int p = 0;
            //IntPtr p = new IntPtr(0);
            uint i = waveOutGetVolume(p, out v);
            uint vleft = v & 0xFFFF;
            uint vright = (v & 0xFFFF0000) >> 16;
            volume = (int.Parse(vleft.ToString()) | int.Parse(vright.ToString())) * (this.trackBar1.Maximum - this.trackBar1.Minimum) / 0xFFFF;
        }

        private void button1_Click(object sender, EventArgs e)
        {

        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            //设置音量
            System.UInt32 Value = (System.UInt32)((double)0xffff * (double)trackBar1.Value / (double)(trackBar1.Maximum - trackBar1.Minimum));//先把trackbar的value值映射到0x0000～0xFFFF范围
           //限制value的取值范围
            if (Value < 0) Value = 0;
            if (Value > 0xffff) Value = 0xffff;
            System.UInt32 left = (System.UInt32)Value;//左声道音量
            System.UInt32 right = (System.UInt32)Value;//右
            waveOutSetVolume(0, left << 16 | right); //"<<"左移，“|”逻辑或运算
        }
    }
}
